﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.IO;
using System.IO.MemoryMappedFiles;

namespace Erettsegi30_FejVagyÍrás
{
    class FejVagyIras
    {
        public static IEnumerable<string> S() //Egyforma dobássorozatokat adja vissza
        {
            using (TextReader tr = new StreamReader("kiserlet.txt"))
            {
                string aktSor = tr.ReadLine();
                while (aktSor != null)
                {
                    while (tr.Peek() == aktSor[0]) aktSor += tr.ReadLine();
                    yield return aktSor;
                    aktSor = tr.ReadLine();
                }
            }
        }

        static void Main()
        {
            Random r = new Random();
            Console.WriteLine("1. feladat\nA pénzfeldobás eredménye: {0}", r.Next(2) == 0 ? 'F' : 'I');
            Console.Write("2. feladat\nTippeljen! (F/I)= ");
            char t = Char.ToUpper(Console.ReadKey().KeyChar);
            char g = r.Next(2) == 0 ? 'F' : 'I';
            Console.WriteLine("\nA tipp {0}, a dobás eredménye {1} volt.\nÖn {2}.", t, g, t == g ? "eltalálta" : "nem találta el");
            Console.WriteLine("3. feladat\nA kísérlet {0} dobásból állt.", S().Sum(x => x.Length));
            Console.WriteLine("4. feladat\nA kísérlet során a fej relatív gyakorisága {0:P2} volt.", (double)S().Where(x => x[0] == 'F').Sum(x => x.Length) / S().Sum(x => x.Length));
            Console.WriteLine("5. feladat\nA kísérlet során {0} alkalommal dobtak pontosan két fejet egymás után.", S().Where(x => x == "FF").Count());
            int fejMax = 0;
            try { fejMax = S().Where(y => y[0] == 'F').Max(y => y.Length); } catch (Exception) { };
            Console.WriteLine("6. feladat\nA leghosszabb tisztafej sorozat {0} tagból áll, kezdete a(z) {1}. dobás.", fejMax,
                fejMax != 0 ? S().TakeWhile(x => x[0] != 'F' || x.Length != fejMax).Sum(x => x.Length) + 1 : 0);
            var d = Enumerable.Range(1, 1000).Select(x => Enumerable.Range(0, 4).Aggregate("", (c, n) => c + "FI"[r.Next(2)])).ToList();
            File.WriteAllText("dobasok.txt", d.Aggregate(String.Format("FFFF: {0}, FFFI: {1}\r\n", d.Count(x => x == "FFFF"), d.Count(x => x == "FFFI")), (c, n) => c + n + ' ').TrimEnd());
            Console.ReadKey();
        }
    }
}
